#ifndef __FIELD_OPERATION__
#define __FIELD_OPERATION__

namespace XMLIOSERVER
{

   class FieldOperation : public AbstractObject
   {
      public :

         FieldOperation(const string& _id = string("inst"), const Duration& _dr = NoneDu)
            : AbstractObject(_id), freqOp(_dr)
         { /* Ne rien faire de plus */ }

         friend std::ostream& operator<<(std::ostream& out, const FieldOperation& fo)
         { out << fo.getId(); return (out); }

         friend std::istream& operator>>(std::istream& in, FieldOperation& fo)
         { string __id; in >> __id; fo.setId(__id); return (in); }

         const Duration& getFreqOp(void) const { return (freqOp); }
         void setFreqOp(const Duration& _dr) { freqOp = _dr; }

      public : /* virtual */

         virtual ~FieldOperation(void)
         { /* Ne rien faire de plus */ }

      protected :

      private :

         Duration freqOp;


   }; // class FieldOperation
} // namespace XMLIOSERVER

#endif //__FIELD_OPERATION__
